create table input.input
(
    id           uuid      not null
        constraint input_pk
            primary key,
    created_at   timestamp not null,
    created_by   text,
    file_content bytea       not null,
    file_type    text,
    dataset_id uuid not null,
    CONSTRAINT unique_dataset_file_type UNIQUE (dataset_id, file_type)
);

comment on column input.input.id is 'UUID generated by BUC';

comment on column input.input.created_by is 'Identifier of the uploading entity (e.g. the bank)';

comment on column input.input.file_content is 'Binary Data Types (https://www.postgresql.org/docs/current/datatype-binary.html)';

comment on column input.input.file_type is 'expected values: [banks, clients, accounts, transactions] ';

create table output.output
(
    id            uuid      not null
        constraint output_pk
            primary key,
    created_at    timestamp not null,
    recipient_id text      not null,
    file_content  bytea   not null,
    report_type     text,
    dataset_id uuid not null,
    participant_identifier text,
    CONSTRAINT unique_dataset_report_type UNIQUE (dataset_id, report_type)
);

comment on column output.output.id is 'UUID generated by UC';

comment on column output.output.recipient_id is 'Identifier of the recipient (can match an uploading organization id) or a 3rd party (e.g. FIU)';

comment on column output.output.file_content is 'Binary Data Types (https://www.postgresql.org/docs/current/datatype-binary.html)';
